--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem-host.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem-host.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,402 @@
+/* Name: mausb_mem-host.c 
+ * Description: Contains hostside-specific memory functions, as well as 
+ * wrappers for functions in mausb_mem.c. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/usb.h> 
+#include <linux/usb/hcd.h> 
+ 
+#include <linux/kthread.h> 
+ 
+#include "mausb_hcd.h" 
+#include "mausb_mem-host.h" 
+#include "mausb_mem.h" 
+#include "mausb_tx.h" 
+#include "mausb_mgmt.h" 
+ 
+/** 
+ * Returns a pointer to the media agnostic data for a given endpoint. 
+ */ 
+struct mausb_host_ep *usb_to_ma_endpoint(struct usb_host_endpoint *ep) 
+{ 
+ return (struct mausb_host_ep *) ep->hcpriv; 
+} 
+ 
+/** 
+ * Returns the number of urbs currently in the MA USB HCD. Will return 0 if the 
+ * MA USB HCD is empty or a negative errno if an error occurs. 
+ */ 
+int mausb_hcd_urb_count(struct mausb_hcd *mhcd) 
+{ 
+ int count = 0; 
+ struct mausb_host_ep *ma_ep; 
+ struct mausb_dev *mausb_dev; 
+ struct mausb_urb *maurb; 
+ unsigned long irq_flags; 
+ 
+ /* for every device */ 
+ spin_lock_irqsave(&mhcd->hcd_lock, irq_flags); 
+ list_for_each_entry(mausb_dev, &mhcd->ma_dev.dev_list, dev_list) { 
+ spin_unlock_irqrestore(&mhcd->hcd_lock, irq_flags); 
+ 
+ /* for every endpoint */ 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ list_for_each_entry(ma_ep, &mausb_dev->ep_list, ep_list) { 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ 
+ /* for every urb */ 
+ spin_lock_irqsave(&ma_ep->ep_lock, irq_flags); 
+ list_for_each_entry(maurb, &ma_ep->urb_list, urb_list) { 
+ ++count; 
+ } 
+ 
+ spin_unlock_irqrestore(&ma_ep->ep_lock, irq_flags); 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ } 
+ 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ spin_lock_irqsave(&mhcd->hcd_lock, irq_flags); 
+ } 
+ 
+ spin_unlock_irqrestore(&mhcd->hcd_lock, irq_flags); 
+ 
+ return count; 
+} 
+ 
+/** 
+ * This function removes a device data from the hcd. All endpoints belonging 
+ * to this device are also removed from the hcd and released (including EP0). 
+ */ 
+void mausb_free_dev(struct usb_hcd *hcd, struct usb_device *dev) 
+{ 
+ struct mausb_hcd *mhcd = usb_hcd_to_mausb_hcd(hcd); 
+ struct ma_dev *ma_dev = &mhcd->ma_dev; 
+ struct mausb_dev *mausb_dev = mausb_find_dev_host(ma_dev, dev); 
+ struct mausb_host_ep *ep0 = list_first_entry(&mausb_dev->ep_list, 
+ struct mausb_host_ep, ep_list); 
+ 
+ if (NULL == mausb_dev) { 
+ mausb_err(mhcd, "%s: USB device #%i not found\n", 
+ __func__, dev->devnum); 
+ return; 
+ } 
+ 
+ ep0->ep_handle_state = MAUSB_EP_HANDLE_INACTIVE; 
+ 
+ /* inactivate EP0 handle */ 
+ mausb_tx_dev_mgmt_req_ep(EPInactivateReq, &mhcd->ma_dev.mgmt, 
+ mausb_dev, true, ep0); 
+ 
+ /* delete remaining EP Handles */ 
+ mausb_tx_dev_mgmt_req(EPHandleDeleteReq, &mhcd->ma_dev.mgmt, 
+ mausb_dev, MAUSB_HOST); 
+ 
+ mausb_tx_dev_mgmt_req(USBDevDisconnectReq, &ma_dev->mgmt, 
+ mausb_dev, MAUSB_HOST); 
+ 
+ mausb_internal_free_dev(ma_dev, mausb_dev); 
+ 
+ return; 
+} 
+ 
+/* 
+ * Adds an endpoint to the specified device. 
+ * 
+ * This function allocates private endpoint data and adds the given endpoint 
+ * to the given device. In the mausb_hcd, devices hold their endpoints in a 
+ * linked list. 
+ */ 
+int mausb_add_endpoint(struct usb_hcd *hcd, struct usb_device *dev, 
+ struct usb_host_endpoint *ep) 
+{ 
+ int status; 
+ char *ep_type; 
+ struct mausb_hcd *mhcd = usb_hcd_to_mausb_hcd(hcd); 
+ struct ma_dev *ma_dev = &mhcd->ma_dev; 
+ struct mausb_dev *mausb_dev; 
+ struct mausb_ms_drv *ms_driver = ma_dev->ms_driver; 
+ struct mausb_host_ep *ma_ep; 
+ 
+ /* don't need to do anything for root hub */ 
+ if ((NULL == dev->parent) && (&dev->ep0 != ep)) 
+ return 0; 
+ 
+ mausb_dev = mausb_find_dev_host(ma_dev, dev); 
+ if (NULL == mausb_dev) { 
+ mausb_err(mhcd, "unable to add endpoint: USB device #%i not" 
+ " found\n", dev->devnum); 
+ return -ENODEV; 
+ } 
+ 
+ status = mausb_internal_add_ep(mausb_dev, ep, NULL, &ma_ep, 
+ &host_transfer_timeout, GFP_KERNEL); 
+ 
+ if (status < 0) { 
+ mausb_err(mhcd, "could not add endpoint: error %i\n", status); 
+ return status; 
+ } 
+ 
+ /* need ms driver before adding endpoint */ 
+ if (NULL == ms_driver) 
+ return -ENODEV; 
+ 
+ /* for debug messages */ 
+ switch (usb_endpoint_type(&ep->desc)) { 
+ case USB_ENDPOINT_XFER_CONTROL: 
+ ep_type = "control"; 
+ break; 
+ case USB_ENDPOINT_XFER_BULK: 
+ ep_type = "bulk"; 
+ break; 
+ case USB_ENDPOINT_XFER_INT: 
+ ep_type = "interrupt"; 
+ break; 
+ case USB_ENDPOINT_XFER_ISOC: 
+ ep_type = "isochronous"; 
+ break; 
+ default: 
+ ep_type = "unknown"; 
+ } 
+ 
+ /* set up control endpoint data channel */ 
+ if (usb_endpoint_type(&ep->desc) == USB_ENDPOINT_XFER_CONTROL) { 
+ status = mausb_add_data_channel(ms_driver, ma_ep, 
+ &complete_control_transferRequest); 
+ } 
+ /* set up bulk IN endpoint data channel */ 
+ else if (usb_endpoint_type(&ep->desc) == USB_ENDPOINT_XFER_BULK 
+ && usb_endpoint_dir_in(&ep->desc)) { 
+ status = mausb_add_data_channel(ms_driver, ma_ep, 
+ &complete_IN_transferRequest); 
+ } 
+ /* set up bulk OUT endpoint data channel */ 
+ else if (usb_endpoint_type(&ep->desc) == USB_ENDPOINT_XFER_BULK 
+ && usb_endpoint_dir_out(&ep->desc)) { 
+ status = mausb_add_data_channel(ms_driver, ma_ep, 
+ &complete_OUT_transferRequest); 
+ } 
+ /* set up an interrupt IN endpoint data channel */ 
+ else if (usb_endpoint_type(&ep->desc) == USB_ENDPOINT_XFER_INT 
+ && usb_endpoint_dir_in(&ep->desc)) { 
+ status = mausb_add_data_channel(ms_driver, ma_ep, 
+ &complete_IN_transferRequest); 
+ } 
+ /* set up an interrupt OUT endpoint data channel */ 
+ else if (usb_endpoint_type(&ep->desc) == USB_ENDPOINT_XFER_INT 
+ && usb_endpoint_dir_out(&ep->desc)) { 
+ status = mausb_add_data_channel(ms_driver, ma_ep, 
+ &complete_OUT_transferRequest); 
+ } else { 
+ mausb_err(mhcd, 
+ "%s: attempted to add channel for ep %i of unsupported" 
+ " type\n", __func__, usb_endpoint_num(&ep->desc)); 
+ return -EOPNOTSUPP; 
+ } 
+ 
+ if (status < 0) { 
+ mausb_err(mhcd, "cannot add %s channel for ep %i: error %i\n", 
+ ep_type, usb_endpoint_num(&ep->desc), status); 
+ /* cleanup endpoint */ 
+ mausb_internal_drop_ep(ma_ep); 
+ } else { 
+ mausb_dbg(mhcd, "%s: added %s channel for ep %i\n", __func__, 
+ ep_type, usb_endpoint_num(&ep->desc)); 
+ } 
+ 
+ return status; 
+} 
+ 
+/* 
+ * Removes an endpoint from the specified device. 
+ * 
+ * This function removes the given endpoint from the given device and releases 
+ * private endpoint data. In the mausb_hcd, devices hold their endpoints in 
+ * a linked list. 
+ * 
+ * TODO: determine & implement proper behavior when endpoint is not 
+ * associated with given device (or is associated with a different 
+ * device) 
+ */ 
+int mausb_drop_endpoint(struct usb_hcd *hcd, struct usb_device *dev, 
+ struct usb_host_endpoint *ep) 
+{ 
+ int ret = 0; 
+ struct mausb_hcd *mhcd = usb_hcd_to_mausb_hcd(hcd); 
+ struct mausb_host_ep *ma_ep = usb_to_ma_endpoint(ep); 
+ struct mausb_dev *ma_dev; 
+ struct mausb_urb *ma_urb, *next_urb; 
+ unsigned long irq_flags; 
+ 
+ if (NULL == ma_ep) { 
+ mausb_err(mhcd, "%s: cannot find data for endpoint at %p\n", 
+ __func__, ep); 
+ return -ENODEV; 
+ } 
+ 
+ ma_dev = ma_ep->mausb_dev; 
+ 
+ mausb_dbg(mhcd, "dropping endpoint at %p to USB device #%i\n", ep, 
+ dev->devnum); 
+ 
+ ret = mausb_tx_dev_mgmt_req_ep(CancelTransferReq, &mhcd->ma_dev.mgmt, 
+ ma_dev, true, ma_ep); 
+ 
+ ma_ep->ep_handle_state = MAUSB_EP_HANDLE_INACTIVE; 
+ 
+ ret = mausb_tx_dev_mgmt_req_ep(EPInactivateReq, &mhcd->ma_dev.mgmt, 
+ ma_dev, true, ma_ep); 
+ 
+ spin_lock_irqsave(&ma_ep->ep_lock, irq_flags); 
+ list_for_each_entry_safe(ma_urb, next_urb, &ma_ep->urb_list, urb_list) { 
+ 
+ mausb_unlink_giveback_urb(ma_urb, -ECONNRESET); 
+ } 
+ 
+ if (!list_empty(&ma_ep->urb_list)) { 
+ mausb_err(mhcd, "%s: could not drop all urbs for ma_ep at %p\n", 
+ __func__, ma_ep->ep); 
+ } 
+ 
+ spin_unlock_irqrestore(&ma_ep->ep_lock, irq_flags); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * This function allocates a new device and adds it onto the MA device's linked 
+ * list of usb devices. It also allocates endpoint data for the control 
+ * endpoint (EP0). 
+ * 
+ * Returns 1 on success or 0 on failure. 
+ */ 
+int mausb_alloc_dev(struct usb_hcd *hcd, struct usb_device *dev) 
+{ 
+ int status = 0; 
+ struct mausb_hcd *mhcd = usb_hcd_to_mausb_hcd(hcd); 
+ struct ma_dev *ma_dev = &mhcd->ma_dev; 
+ struct mausb_dev *mausb_dev; 
+ 
+ mausb_dev = mausb_internal_alloc_dev(ma_dev, dev, NULL); 
+ if (NULL == mausb_dev) 
+ return 0; 
+ 
+ /* add EP0 */ 
+ mausb_dbg(mhcd, "%s: adding EP0 . . .\n", __func__); 
+ status = mausb_add_endpoint(hcd, dev, &dev->ep0); 
+ 
+ /* 
+ * Don't add send the EP Request yet, usbcore hasn't set 
+ * the ep0 descriptor. Wait until a datapacket is sent. 
+ */ 
+ 
+ if (status >= 0) 
+ return 1; 
+ 
+ /* TODO: drop endpoint here if failure */ 
+ mausb_free_dev(hcd, dev); 
+ mausb_err(mhcd, "%s: could not add EP0 %i\n", __func__, status); 
+ return 0; 
+} 
+ 
+/** 
+ * USB core calls the HCD's check_bandwidth function immediately after adding 
+ * or deleting endpoints. 
+ */ 
+int mausb_check_bandwidth(struct usb_hcd *hcd, struct usb_device *dev) 
+{ 
+ int status; 
+ struct mausb_hcd *mhcd = usb_hcd_to_mausb_hcd(hcd); 
+ struct ma_dev *ma_dev = &mhcd->ma_dev; 
+ struct mausb_dev *mausb_dev = mausb_find_dev_host(ma_dev, dev); 
+ 
+ /* don't do anything if roothub */ 
+ if (NULL == dev->parent) 
+ return 0; 
+ 
+ if (NULL == mausb_dev) { 
+ mausb_err(mhcd, "%s: could not find data for USB device #%i\n", 
+ __func__, dev->devnum); 
+ return -ENODEV; 
+ } 
+ 
+ /* delete the old endpoints (if applicable) */ 
+ status = mausb_tx_dev_mgmt_req(EPHandleDeleteReq, &ma_dev->mgmt, 
+ mausb_dev, MAUSB_HOST); 
+ 
+ /* TODO: error checking (suppose the EPHandleDelete fails...) */ 
+ 
+ /* add the new endpoints (if applicable) */ 
+ status = mausb_tx_dev_mgmt_req(EPHandleReq, &ma_dev->mgmt, mausb_dev, 
+ MAUSB_HOST); 
+ 
+ if (-ENODEV == status) /* no endpoints were applicable */ 
+ status = 0; 
+ 
+ return status; 
+} 
+ 
+/** 
+ * This function will be called if mausb_add_endpoint(), mausb_drop_ep(), 
+ * or mausb_check_bandwidth returns with an error. It is supposed to revert 
+ * a device to a previously good schedule. We assume any schedule will work, 
+ * so we should, in theory, never have to revert to a previous schedule. 
+ */ 
+void mausb_reset_bandwidth(struct usb_hcd *hcd, struct usb_device *dev) 
+{ 
+ mausb_dbg(usb_hcd_to_mausb_hcd(hcd), 
+ "resetting bandwidth for USB edvice #%i\n", dev->devnum); 
+ return; 
+} 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem-host.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem-host.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem-host.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem-host.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,74 @@
+/* Name: mausb_mem-host.h 
+ * Description: header for mausb_mem-host.c 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_MEM_HOST_H 
+#define __MAUSB_MEM_HOST_H 
+ 
+/* endpoint/device helper functions */ 
+struct mausb_host_ep *usb_to_ma_endpoint(struct usb_host_endpoint *ep); 
+int mausb_hcd_urb_count(struct mausb_hcd *mhcd); 
+ 
+/* USB core interfaces */ 
+int mausb_alloc_dev(struct usb_hcd *hcd, struct usb_device *dev); 
+void mausb_free_dev(struct usb_hcd *hcd, struct usb_device *dev); 
+int mausb_add_endpoint(struct usb_hcd *hcd, struct usb_device *dev, 
+ struct usb_host_endpoint *ep); 
+int mausb_drop_endpoint(struct usb_hcd *hcd, struct usb_device *dev, 
+ struct usb_host_endpoint *ep); 
+int mausb_check_bandwidth(struct usb_hcd *hcd, struct usb_device *dev); 
+void mausb_reset_bandwidth(struct usb_hcd *hcd, struct usb_device *dev); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mgmt.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mgmt.c
